#!/bin/csh -f
#
# Here are some hints for creating a csh script ...
#
# > The first line must be identical to the first line of this file
#
# > To set a variable:
#      set varName = value    e.g.  set var1 = 12.0
#
# > Integer Calculations:
#      @ varName = $varName1*$varName2  (varName must exist)
#      @ varName = $varName1/$varName2
#
# > Floating Point Calculations (must use rpnl tool):
#      set varName = `rpnl "$varName1 $varName2 *"`
#      set varName = `rpnl "$varName1 $varName2 /"`
#
# > Flow control:
#      if ($varName > 102) then
#          echo 'if statement passed'
#      else
#          echo 'if statement failed'
#      endif
#
#      while ($varName > 102)
#          sleep 1
#      end
#
# > Debugging:
#      set echo   (early in the script)
#
# > Channel Access examples :
#      caput PV_NAME "value"
#      caput PV_NAME $varName  ($varName is replaced with the value of varName)
#      set varName = `caget -t -n PV_NAME`
#
#
#
#set echo

set beamOn = `caget -t -n studnt0:gunOnC`

while ($beamOn == 1)
    set FC1 = `caget -t -n studnt0:FC1:intensityM` 
    set CM1 = `caget -t -n studnt0:CM1:intensityM`
    if ($CM1 != 0) then
        set Eff = `rpnl "$FC1 $CM1 /"`
    else
        set Eff = 0
    endif
   
    caput studnt0:opVariable1 $Eff

    sleep 1

    set beamOn = `caget -t -n studnt0:gunOnC`

end

echo 'Beam Off'

exit
