/* Device support template for the Multi-Bit Binary Input (mbbiDirect) record */

/* vxWorks headers */
#include <vxWorks.h>
#include <sysLib.h>
#include <vxLib.h>
#include <intLib.h>
#include <iv.h>
#include <vme.h>

/* EPICS headers */
#include <devSup.h>
#include <recSup.h>
#include <dbScan.h>
#include <mbbiDirectRecord.h>


/* Local declarations and definitions */
struct ... {
    ...
};


/* Status report function */

static long report(int level) {
    ...
    
    return 0;
}


/* Device Support init routine */

static long initialize(int pass) {
    if (pass == 0) {
	/* Before any individual record initialization */
	...
    } else {
	/* After all individual record initialization */
	...
    }
    
    return 0;
}


/* Interrupt Service Routine */

static void interrupt(int parameter) {
    ...
    
    scanIoRequest(...);
    
    return;
}


/* Initialize a record */

static long initRecord(struct mbbiDirectRecord *prec) {
    char *vmeAddr, dummy;
    struct ... *pcard;
    
    prec->pact = 1;
    
    if ((prec->inp.type != ...) || 
	(prec->inp.value.... < ...) ||
	(prec->inp.value.... > ...)) {
	recGblRecordError(S_dev_badInpType, (void *)prec,
		"devMbbiDirect...: Bad Inp address");
	return S_dev_badInpType;
    }
    
    vmeAddr = ...;
    if (sysBusToLocalAdrs(VME_AM_SUP_SHORT_IO, vmeAddr, 
		(char **)&pcard) == ERROR) {
	recGblRecordError(S_dev_..., (void *)prec,
		"devMbbiDirect...: VME address conversion failed");
	return S_dev_...;
    }
    
    if (vxMemProbe((char *)&(pcard->...), READ, sizeof(dummy), &dummy) < 0) {
	recGblRecordError(S_dev_..., (void *)prec,
		"devMbbiDirect...: I/O card not present");
	return S_dev_...;
    }
    
    ...
    
    if (intConnect(INUM_TO_IVEC(...), interrupt, ...) < 0) {
	...
	return S_dev_...;
    }
    scanIoInit(&...);
    
    ...
    
    prec->dpvt = ...;
    prec->shft = ...;
    prec->mask <<= prec->shft;
    
    prec->pact = 0;	/* Initialized Ok, allow record to process */
    return 0;
}


/* I/O Interrupt support */

static long getIoIntInfo(int cmd, struct mbbiDirectRecord *prec, IOSCANPVT *ppvt) {
    
    *ppvt = ...;
    
    return 0;
}


/* Hardware input routine */

static long read(struct mbbiDirectRecord *prec) {
    ...
    
    prec->rval = ... & prec->mask;
    
    return 0;	/* Convert */
}


/* Device Support Entry Table */

struct dset {
    long number;
    long (*report)(int level);
    long (*initialize)(int pass);
    long (*initRecord)(struct mbbiDirectRecord *prec);
    long (*getIoIntInfo)(int cmd, struct mbbiDirectRecord *prec, IOSCANPVT *ppvt);
    long (*read)(struct mbbiDirectRecord *prec);
} devMbbiDirect... = {
    5,
    NULL,	/* report, */
    NULL,	/* initialize, */
    initRecord,
    NULL,	/* getIoIntInfo, */
    read
};
