/* Device support template for the Multi-Bit BO Direct (mbboDirect) record */

/* vxWorks headers */
#include <vxWorks.h>
#include <sysLib.h>
#include <vxLib.h>
#include <intLib.h>
#include <vme.h>

/* EPICS headers */
#include <devSup.h>
#include <recSup.h>
#include <mbboDirectRecord.h>


/* Local declarations and definitions */
struct ... {
    ...
};


/* Status report function */

static long report(int level) {
    ...
    
    return 0;
}


/* Device Support init routine */

static long initialize(int pass) {
    if (pass == 0) {
	/* Before any individual record initialization */
	...
    } else {
	/* After all individual record initialization */
	...
    }
    
    return 0;
}


/* Initialize a record */

static long initRecord(struct mbboDirectRecord *precord) {
    char *vmeAddr, dummy;
    struct ... *pcard;
    
    precord->pact = 1;
    
    if ((precord->out.type != ...) || 
	(precord->out.value.... < ...) ||
	(precord->out.value.... > ...)) {
	recGblRecordError(S_dev_badOutType, (void *)precord,
		"devMbboDirect...: Bad OUT address");
	return S_dev_badOutType;
    }
    
    vmeAddr = ...;
    if (sysBusToLocalAdrs(VME_AM_SUP_SHORT_IO, vmeAddr, 
		(char **)&pcard) == ERROR) {
	recGblRecordError(S_dev_..., (void *)precord,
		"devMbboDirect...: VME address conversion failed");
	return S_dev_...;
    }
    
    if (vxMemProbe((char *)&(pcard->...), READ, sizeof(dummy), &dummy) < 0) {
	recGblRecordError(S_dev_..., (void *)precord,
		"devMbboDirect...: I/O card not present");
	return S_dev_...;
    }
    
    ...
    
    precord->dpvt = ...;
    precord->shft = ...;
    precord->mask <<= precord->shft;
    
    precord->pact = 0;	/* Initialized Ok, allow record to process */
    return 0;
}


/* Hardware output routine */

static long write(struct mbboDirectRecord *precord) {
    int lockKey;
    ...
    
    lockKey = intLock();
    ... = (... & ~precord->mask) | (precord->rval & precord->mask);
    intUnlock(lockKey);
    
    return 0;
}


/* Device Support Entry Table */

struct dset {
    long number;
    long (*report)(int level);
    long (*initialize)(int pass);
    long (*initRecord)(struct mbboDirectRecord *prec);
    long (*getIntInfo)(int cmd, struct mbboDirectRecord *prec, IOSCANPVT *ppvt);
    long (*write)(struct mbboDirectRecord *prec);
} devMbboDirect... = {
    5,
    NULL,	/* report, */
    NULL,	/* initialize, */
    initRecord,
    NULL,	/* getIoIntInfo, */
    write
};
