program stabilizer

%%#include <taskLib.h>

short   enableButton;
assign  enableButton to "{user}:OP:stabilizerC";
monitor enableButton;

float   cathodeTemp;
assign  cathodeTemp to "{user}:cathodeTempM";
monitor cathodeTemp;

float   cathodeCurrent;
assign  cathodeCurrent to "{user}:cathodeCurrentC";

string  statusMsg;
assign  statusMsg to "{user}:OP:stabilizerMsg";

float   gain;
assign  gain to "{user}:OP:stabilizerGain";
monitor gain;

float   setpoint;
float   error;

ss stabilizerSS1 
{
  state init
    {
        when(1)
            {
            } state waitForEnable
    } 


  state waitForEnable
    {
	when(enableButton)
	    {
	      setpoint = cathodeTemp;
	      sprintf(statusMsg, "Starting Stabilizer; SP = %f",setpoint);
	      pvPut(statusMsg);
%%            taskDelay(60);
	    } state stabilize
    }

  state stabilize
    {
        when(!enableButton)
            {
	      sprintf(statusMsg, "Stopping Stabilizer");
	      pvPut(statusMsg);
            } state waitForEnable

        when(delay(.5))
            {
	      pvGet(cathodeCurrent);
	      error = setpoint - cathodeTemp;
              cathodeCurrent = cathodeCurrent + (gain * error);
	      pvPut(cathodeCurrent);
	      sprintf(statusMsg, "error = %.3f, cath = %.3f",
				  error,cathodeCurrent);
	      pvPut(statusMsg);
            } state stabilize
    } 
}
